(function($) {
  /**
   * @todo
   */
  
  Drupal.behaviors.bizreviewDropdownMenu = {
    attach: function (context) {
       //////////////// Mobile Menu Toggle
        
      $('.nav-mobile-toggle').on('click', function(){
        $('nav').toggleClass('nav-open');
      });
    
      $('.menu li').on('click', function(ev){
          var navItem = $(this),
              e       = ev || window.event;
          
          e.stopPropagation();
          if (navItem.find('ul').length) {
              navItem.toggleClass('active');
          } else {
              navItem.parents('.active').removeClass('active');
          }
      });
      
            
      //////////////// Menu dropdown positioning

      $('.menu > li > ul').each(function() {
          var $window          = $(window);
          var dropDown         = $(this);
          var menu             = dropDown.offset();
          var farRight         = menu.left + dropDown.outerWidth(true);
          var windowWidth      = $window.width();

          if (farRight > windowWidth) {
              dropDown.addClass('make-right');
          }
      });
      
    }
  };
  Drupal.behaviors.bizreviewBackgroundImage = {
    attach: function (context) {
        $('.background-image-holder').each(function(){
          var imgSrc= $(this).children('img').attr('src');
          $(this).css('background', 'url("' + imgSrc + '")');
          $(this).children('img').hide();
          $(this).css('background-position', '50% 0%');
          $(this).css('opacity','1')
        });
    }
  };
  Drupal.behaviors.bizreviewGalleryPage = {
    attach: function (context) {
      $('#listing-featured-slider .field-image, .view-member .views-field-picture, .view-meet-our-team .views-field-field-image,.view-events .views-field-field-event-image').hover(
        function () {
		  $(this).addClass('hover');
        },
        function () {
		  $(this).removeClass('hover');
        }
      );
    }
  };

  Drupal.behaviors.bizreviewStar = {
    attach: function (context) {
      $('span.stars').each(function() {
        if(!$(this).hasClass('added-star')) {
          $(this).html($('<span />').width(Math.max(0, (Math.min(5, parseFloat($(this).html())))) * 24));
        }
        $(this).addClass('added-star');
      })

      $('span.stars-small, .starrating').each(function() {
        if(!$(this).hasClass('added-star')) {
          $(this).html($('<span />').width(Math.max(0, (Math.min(5, parseFloat($(this).html())))) * 18));
        }
        $(this).addClass('added-star');
      })
    }
  };
  
/*
  Drupal.behaviors.bizreviewThemeColors = {
    attach: function (context) {
      $('body', context).once('block-theme-colors-showhide', function () {							   
        jQuery('.block-theme-colors .close').click(function(e){
		  e.preventDefault();
		  jQuery('.block-theme-colors .block-theme-color-content ').hide();
		  jQuery(this).hide();
		  jQuery('.block-theme-colors .open').show();
		});
		jQuery('.block-theme-colors .open').click(function(e){
          e.preventDefault();
		  jQuery('.block-theme-colors .block-theme-color-content ').show();
		  jQuery(this).hide();
		  jQuery('.block-theme-colors .close').show();
		});  
      });
    }
  };
  */

  Drupal.behaviors.bizreviewSearchResult = {
    attach: function (context) {
        $(window).bind('resize', function() {
				var searchResult = document.querySelector("#listing-search-results");
				if (searchResult) {
					var searchMap = document.querySelector("#listing-search-results-map"); 
					var position = getPosition(searchResult);
					var curHeight = $(window).height() - position.y - 20;
					var windowWidth = $(window).width();
					var searchResultWidth = $("#listing-search-results").width();
					var mapWidth = windowWidth - searchResultWidth - 40;
					if (windowWidth > 768) {
					  searchResult.style.height= curHeight + "px";		
					  searchMap.style.height= curHeight + "px";	
					  searchMap.style.width= mapWidth + "px";
					}
					else {
					  searchResult.style.height= "auto";		
					  searchMap.style.height= "auto";
					  searchMap.style.width= "100%";
					}
				}
				
				function getPosition(el) {
				  var xPos = 0;
				  var yPos = 0;
				 
				  while (el) {
					if (el.tagName == "BODY") {
					  // deal with browser quirks with body/window/document and page scroll
					  var xScroll = el.scrollLeft || document.documentElement.scrollLeft;
					  var yScroll = el.scrollTop || document.documentElement.scrollTop;
				 
					  xPos += (el.offsetLeft - xScroll + el.clientLeft);
					  yPos += (el.offsetTop - yScroll + el.clientTop);
					} else {
					  // for all other non-BODY elements
					  xPos += (el.offsetLeft - el.scrollLeft + el.clientLeft);
					  yPos += (el.offsetTop - el.scrollTop + el.clientTop);
					}
				 
					el = el.offsetParent;
				  }
				  return {
					x: xPos,
					y: yPos
				  };
				}

        }).trigger('resize');

    }
  };

  /*
   * Disable search button on List Indexed Business view if the search box is empty
   */
  /*Drupal.behaviors.bizreviewSearchSubmit = {
    attach: function (context) {
      // Disable the submit button by default
      $('button#edit-submit-list-indexed-business').attr('disabled', 'disable');

      // Check if the search box is not empty to enable the submit button
      $('#edit-search-api-views-fulltext').keyup(function () {		
	if ($(this).val().length == 0) {
	  $('button#edit-submit-list-indexed-business').attr('disabled', 'disable');
	}
	else {
	  $('button#edit-submit-list-indexed-business').removeAttr('disabled');
	}

      });
    }
  };*/

})(jQuery);

